Program Sierra_Unprotect ; {$S-}

{$M $4000, $4000, $4000 }

{ Version 2.01 - 1990-03-30 }
{ Updated to include Helicopter version 1.10 }


Uses
   Dos,Crt ;

Type
   ProtectBufferType = Array [0..8191] of Byte ;
   BufferInUseType   = (Normal,Spare) ;

Var
   WhereDMA      : Word ;
   BufferInUse   : BufferInUseType ;
   ProtectTrack  : Array [Normal .. Spare] of ProtectBufferType ;
   InOutFile     : File ;
   SomethingUnprotected : Boolean ;



Procedure TryUnprotection (FName : String);

Type
   CodeArray    = Array [0..5] of char ;
   NopTypeArray = Array [0..2] of char ;

Var
   FileDate     : LongInt   ;
   ReadArray    : Codearray ;
   ReadNopArray : NopTypeArray ;
   Version      : Integer ;
   KeyOffset    : Word ;

Const
   MaxVersion = 7 ;
   CheckArray : Array[1..MaxVersion] of CodeArray = (
                            (#$E8,#$C3,#$00,#$A3,#$2C,#$03),
                            (#$E8,#$9A,#$00,#$A3,#$15,#$03),
                            (#$BB,#$FF,#$FF,#$B4,#$48,#$CD),
                            (#$BB,#$FF,#$FF,#$B4,#$48,#$CD),
                            (#$E8,#$B5,#$00,#$8D,#$16,#$C1),
                            (#$BB,#$FF,#$FF,#$B4,#$48,#$CD),
                            (#$E8,#$97,#$00,#$8D,#$16,#$C1)
                                                     );
   AddressArray : Array[1..MaxVersion] of Word =
                            ($252,$269,$290,$298,$2C4,$2E4,$257);
   NopArray   : NopTypeArray = (#$90,#$90,#$90)    ;


Begin
   FileMode := 0 ;

   Assign ( InOutFile , FName ) ;
   {$I-}
   Reset (InOutFile,1);
   {$I+}
   If IOResult <> 0 then Exit ;

   { ***** Find the time and date of the file ***** }
   GetFTime (InOutFile,FileDate);

   { ***** Check that this is actually a Sierra loader ***** }

   Seek(InOutFile,3);
   BlockRead(InOutFile,ReadArray,6);
   If ReadArray <> 'LOADER' then
      Begin
         Close (InOutFile) ;
         Exit ;
      End ;
   Write (FName,' - ') ;
   Version := 0 ;
   Repeat
      Inc(Version);
      Seek(InOutFile,AddressArray[Version]);
      BlockRead(InOutFile,ReadArray,6);
   Until (ReadArray = CheckArray[Version]) or (Version = MaxVersion) ;

   If (ReadArray = CheckArray[Version]) then
      Begin

         { ***** See if the file has already been patched ***** }
         Seek(InOutFile,AddressArray[Version] - 3);
         BlockRead(InOutFile,ReadNopArray,3);
         Close(InOutFile);
         If ReadNopArray = NopArray then
            Begin
               WriteLn('this file has already been unprotected.');
               Exit ;
            End ;

         { ***** Find the offset in the crypto key buffer. ***** }
         FileMode := 2 ;
         Assign ( InOutFile , FName ) ;
         Reset (InOutFile,1);

         Seek(InOutFile,$3F);
         BlockRead(InOutFile,KeyOffset,2);

         { ***** Write the crypto key to the file. ***** }
         Seek(InOutFile,$41);
         BlockWrite(InOutFile,ProtectTrack[BufferInUse][KeyOffset],128);

         { ***** Insert NOPs where the call to check ***** }
         { ***** copy protection used to be.         ***** }
         Seek(InOutFile,AddressArray[Version] - 3);
         BlockWrite(InOutFile,NopArray,3);
         SetFTime(InOutFile,FileDate);
         Close(InOutFile);
         WriteLn ('unprotected!');
         SomethingUnprotected := True ;
      End
   Else
      Begin
         Close (InOutFile) ;
         WriteLn ('this loader is of a version I cannot handle.');
      End ;

End ; { Procedure TryUnprotection }



Procedure CheckTrack6 ;

Var
   Retries, Indx : Integer ;
   Regs          : Registers ;
   SaveDBT       : Pointer ;
   ChkSum        : Word ;

Const
   DiskBaseTable : Array[1..11] of Byte =
                         ($CF,$02,$25,$06,$01,$2A,$FF,$50,$F6,$19,$04) ;

Begin

   ClrScr ;
   WriteLn ('Please insert your ORIGINAL game diskette 1 in drive A:') ;
   WriteLn ('This diskette MUST be write protected.') ;
   WriteLn ('Hit the <ENTER>-key when ready... ') ;
   WriteLn ;

   Repeat until Not KeyPressed ;
   Repeat until ReadKey = #13 ;

   FileMode := 0 ;
   Assign (InOutFile,'A:\CPC.COM');
   {$I-}
   Reset (InoutFile,1);
   {$I+}
   If IOResult <> 0 then
       Begin
          WriteLn ('That did not look like your ORIGINAL game diskette.');
          WriteLn ;
          Halt ;
       End ;
    Close (InOutFile);
    FileMode := 2 ;

    GetIntVec($1E,SaveDBT);
    SetIntVec($1E,@DiskBaseTable);
    Retries := 3 ;
    With Regs do
       Repeat

          AH := 0 ; { Reset diskette system }
          If Retries <> 3 then
             Intr ($13,Regs) ;

          AH := 2 ; { Read operation }
          DL := 0 ; { Drive }
          DH := 0 ; { Head  }
          CH := 6 ; { Track }
          CL := 1 ; { Sector }
          AL := 1 ; { Number of Sectors }
          ES := Seg(ProtectTrack[BufferInUse]) ;
          BX := Ofs(ProtectTrack[BufferInUse]) ;
          Intr ($13,Regs) ;
          Dec (Retries) ;

       Until (AH = $10) or (Retries = 0) ;

    SetIntVec($1E,SaveDBT);

    ChkSum := 0 ;

    If (Regs.AH = $10) then
       For Indx := 0 to 511 do
          ChkSum := ChkSum + ProtectTrack[BufferInUse][Indx] ;

    If (ChkSum <> 28) then
       Begin
          WriteLn ('Sorry, but the copy protection check failed.');
          WriteLn ('Unable to continue.');
          WriteLn ;
          Halt ;
       End ;

    WriteLn ('Thankyou.');
    WriteLn ;

End ; { Procedure CheckTrack6 }



Procedure Unprotect (Filename : String ;
                     HardDisk : Boolean) ;

Type
   LinkRecPointerType = ^LinkRec ;
   LinkRec = Record
                Next : LinkRecPointerType ;
                FoundFile : SearchRec ;
             End ;

Var
   MarkPointer : Pointer ;
   FirstDirPoint,
   FirstFilePoint,
   OldPoint,
   NewPoint    : LinkRecPointerType ;
   FoundFiles  : SearchRec ;


Begin
   CheckTrack6 ;
   If HardDisk then
      Begin
         FindFirst (FileName + '\SIERRA\*.*',Directory,FoundFiles) ;
         If DosError = 0 then
            Begin
               FirstDirPoint := Nil ;
               Repeat
                  If (FoundFiles.Attr = Directory) and
                     (FoundFiles.Name[1] <> '.') then
                     Begin
                        New (NewPoint) ;
                        NewPoint^.Next := Nil ;
                        NewPoint^.FoundFile := FoundFiles ;
                        If FirstDirPoint = Nil then
                           FirstDirPoint := NewPoint
                        else
                           OldPoint^.Next := NewPoint ;
                        OldPoint := NewPoint ;
                     End ;
                  FindNext(FoundFiles) ;
               Until DosError <> 0 ;
               FileName := FileName + '\SIERRA\' ;
            End
         Else
            Begin
               WriteLn ('Can''t find directory: ',FileName + '\SIERRA');
            End ;
      End
   Else
      Begin
         New(FirstDirPoint) ;
         FirstDirPoint^.FoundFile.Name := '' ;
         FirstDirPoint^.Next := Nil ;

         WriteLn ('Please insert your "PLAY" diskette 1 in drive ',FileName) ;
         WriteLn ('This diskette must NOT be write protected.') ;
         WriteLn ('Hit the <ENTER>-key when ready... ') ;
         WriteLn ;

         Repeat until Not KeyPressed ;
         Repeat until ReadKey = #13 ;
      End ;



   While FirstDirPoint <> Nil do
      Begin
         Mark (MarkPointer) ;
         FirstFilePoint := Nil ;
         FindFirst (FileName +
                    FirstDirPoint^.FoundFile.Name + '\*.COM',
                    Archive, FoundFiles) ;
         If DosError = 0 then
            Repeat
               New(NewPoint) ;
               NewPoint^.Next := Nil ;
               NewPoint^.FoundFile := FoundFiles ;
               If FirstFilePoint = Nil then
                  FirstFilePoint := NewPoint
               else
                  OldPoint^.Next := NewPoint ;
               OldPoint := NewPoint ;
               FindNext (FoundFiles) ;
            Until DosError <> 0 ;
         While FirstFilePoint <> Nil do
            Begin
               TryUnprotection (FileName +
                                FirstDirPoint^.FoundFile.Name +
                                '\' + FirstFilePoint^.FoundFile.Name) ;
               FirstFilePoint := FirstFilePoint^.Next ;
            End ;
         FirstDirPoint := FirstDirPoint^.Next ;
         Release (MarkPointer) ;
      End ;

End ; { Procedure Unprotect }


Procedure Menu ; { Main Menu }

Const
   SelTexts : Array [0..2] of String[67] =
   ('1. Unprotect diskette copy ("PLAY"-disk) in drive A:               ',
    '2. Express unprotect of all Sierra games installed on hard disk C: ',
    '3. Exit to DOS                                                     ') ;

Var
   Val,Dr,Dr1 : Integer ;
   I          : Word ;
   FKey       : Boolean ;
   Ch         : Char ;

Begin
   Val := 0 ;
   Dr := 1 ;
   Dr1 := 2 ;
   Repeat
      ClrScr ;
      WriteLn ('Select desired function: ') ;
      WriteLn ('=========================') ;
      Repeat
         For I := 0 to 2 do
            Begin
               GotoXY (7, I*2 + 4) ;
               If I = Val Then
                  Begin
                     TextColor (Black) ;
                     TextBackground (LightGray) ;
                  End
               Else
                  Begin
                     TextColor (LightGray) ;
                     TextBackground (Black) ;
                  End ;
               Write (SelTexts[I]) ;
               If I = 0 then
                  Begin
                     GotoXY (57, 4) ;
                     Write (Chr (Dr + 65));
                  End ;
               If I = 1 then
                  Begin
                     GotoXY (71, 6) ;
                     Write (Chr (Dr1 + 65));
                  End ;
               TextColor (LightGray) ;
               TextBackGround (Black ) ;
               WriteLn ;
               WriteLn ;
            End ;
         Ch := ReadKey ;
         If Ch <> #0 then FKey := False else
            Begin
               FKey := True ;
               Ch := ReadKey
            End ;
         If FKey then
            Case Ch of
               #71 : { Home }
                     Val := 0 ;
               #79 : { End }
                     Val := 2 ;
               #72 : { Upptpil }
                     Dec (Val) ;
               #80 : { Nedtpil }
                     Inc (Val) ;
               #75 : { Vnsterpil }
                     If Val = 0 then Dec (Dr)
                        else
                           If Val = 1 then Dec (Dr1) ;
               #77 : { Hgerpil }
                     If Val = 0 then Inc (Dr)
                        else
                           If Val = 1 then Inc (Dr1) ;
            End { Case }
         Else
            Case UpCase(Ch) of
               'A'..'Z' : If Val = 0 then Dr := Ord(UpCase(Ch)) - Ord('A')
                             else If Val = 1 then Dr1 :=
                                                Ord(UpCase(Ch)) - Ord('A');
               '1'..'3' : Val := Ord (Ch) - Ord ('1') ;
            End ; { Case }
         If Dr < 0 then Dr := 3 ;
         If Dr > 3 then Dr := 0 ;
         If Dr1 < 2 then Dr1 := Ord('Z') - Ord ('A') ;
         If Dr1 > (Ord('Z') - Ord ('A')) then Dr1 := 2 ;
         If Val < 0 then Val := 2 ;
         If Val > 2 then Val := 0 ;
      Until (Ch in [#13,#27]) and Not FKey ;

      If Ch <> #27 then
         Case Val Of
            0 : UnProtect (Chr (Dr + Ord('A')) + ':', False) ;
                { Call to diskette unprotect }
            1 : Unprotect (Chr (Dr1 + Ord('A')) + ':', True) ;
                { Call to hard disk unprotect }
            2 : Begin
                   ClrScr ;
                   Halt ;
                End ;
         End { Case }
      Else
         Begin
            ClrScr ;
            Halt ;
         End ;

   Until Ch = #13 ;

End ;



Begin { Program Sierra_Unprotect }

   SetIntVec($24,SaveInt24);
   CheckBreak := False ;

   SomethingUnprotected := False ;

   { ***** Find a buffer that does not overlap a 64 k boundary ***** }
   BufferInUse := Normal ;
   WhereDMA := (Seg(ProtectTrack[BufferInUse]) shl 4) +
                Ofs(ProtectTrack[BufferInUse]) ;
   If WhereDMA > 57344 then BufferInUse := Spare ;

   ClrScr ;
   WriteLn ('The "SUP" Unprotection Program, version 2.01. Copyright Anders M Olsson, 1988.');
   WriteLn ('=============================================================================');
   WriteLn ;
   WriteLn ('"SIERRA" is a registered trademark of Sierra On-Line, Inc.');
   WriteLn ;
   WriteLn ('This software is provided for lawful purposes only. By using this product, you');
   WriteLn ('agree to be bound by applicable laws, license agreements and copyright notices.');
   WriteLn ('You are NOT allowed to give away or sell unprotected copies of Sierra games');
   WriteLn ('produced with the aid of this program.');
   WriteLn ;
   WriteLn ('However, this program (SUP.EXE) together with its documentation file is');
   WriteLn ('distributed on a "shareware" basis. You are encouraged to give away, but not');
   WriteLn ('sell, unaltered copies of this unprotection program. Any copy must be');
   WriteLn ('accompanied by the documentation file SUP.DOC. No guarantee is given, and');
   WriteLn ('no responsibility will be accepted for any damage caused by using this');
   WriteLn ('product.');
   WriteLn ;
   Write   ('Hit the <ENTER>-key to begin... ');

   Repeat Until Not KeyPressed ;
   Repeat Until ReadKey = #13 ;

   If ParamCount = 1 then
      Begin
         CheckTrack6 ;
         TryUnprotection (ParamStr(1))
      End
   else
      Menu ;

   If SomethingUnprotected then
      Begin
         WriteLn ;
         WriteLn ('If you found this program useful, your contribution of U.S. $ 10:- or');
         WriteLn ('Swedish Kronor 50:- would be appreciated. Assist me in my struggle');
         WriteLn ('against copy protection!');
         WriteLn ;
         WriteLn ('                                   Anders M Olsson');
         WriteLn ('                                   Jaktstigen 37');
         WriteLn ('                                   S-222 52  Lund');
         WriteLn ('                                   SWEDEN');
         WriteLn ;
      End
   Else
      Begin
         WriteLn ;
         WriteLn ('Could not find anything to unprotect.') ;
         WriteLn ;
      End ;

End . { Program Sierra_Unprotect }